#include "main.h"

////////////////////////////////////////////////////////////////////////
int main()
////////////////////////////////////////////////////////////////////////
{
  try{

    McCormick::np(2);
 
    const int nx = 20, ny = 20;
    const double xl=-1, xu=1;
    const double yl=-1, yu=1;
  
    for( int ix=0; ix<nx; ix++ ){ 
      for( int iy=0; iy<ny; iy++ ){

        McCormick X( xl, xu, xl+ix*(xu-xl)/(nx-1.), 0 );
        McCormick Y( yl, yu, yl+iy*(yu-yl)/(ny-1.), 1 );
        //McCormick Z = +xlog(pow(X-Y,2)+0.1);
        McCormick Z = +sqrt(fabs(X-Y));

        //double ZNC = xlog(pow(X.cv()-Y.cv(),2)+0.1);
        double ZNC = sqrt(fabs(X.cv()-Y.cv()));

        cout << X.cv() << "  " << Y.cv() << "  " << ZNC << "  "
             << Z.l() << "  " << Z.u() << "  "
             << Z.cv() << "  " << Z.cc() << "  "
             << Z.dcvdp(0) << "  " << Z.dccdp(0) << "  "
             << Z.dcvdp(1) << "  " << Z.dccdp(1)
             << endl;
      }
      cout << endl;
    }  

  }
  catch( MC_Excp &eObj ){
    cerr << "Error " << eObj.ierr() << " in McCormick relaxation." << endl
         << "Execution aborted..." << endl;
    return eObj.ierr();
  }

  return 0;
}
