#include "main.h"

////////////////////////////////////////////////////////////////////////
int main()
////////////////////////////////////////////////////////////////////////
{
  McCormick::np(1);
 
  const double dx = 0.01;

  const double xl=0.4,xu=0.6;
  const double xbar=0.5;
  McCormick X( xl, xu, xbar, 0 );
  McCormick Y=1-X;
  McCormick Z = xlog(Y);

  try{
    const double gu=Z.cv(), dgudx=Z.dcvdp(0), go=Z.cc(), dgodx=Z.dccdp(0);
    cerr << xbar << "  "   << Z.cv() << "  " << Z.cc() << "  "
         << dgudx  << "  " << dgodx     << endl;   
    
    for (double xm=xl ; xm <= xu ; xm +=dx) {
      McCormick X( xl, xu, xm, 0 );
      McCormick Y=1-X;   
      McCormick Z = xlog(Y);
      const double g= xlog(1-xm);
      cout << xm << "  "  << g << "  " << Z.l() << "  " << Z.u() << "  "
           << Z.cv() << "  " << Z.cc() << "  "  << gu+ (xm-xbar)*dgudx  << "  "
           << go+ (xm-xbar)*dgodx  << endl;
    }
    
  }
  catch( MC_Excp &eObj ){
    cerr << "Error " << eObj.ierr() << " in McCormick relaxation." << endl
         << "Execution aborted..." << endl;
    return eObj.ierr();
  }
  return 0;
}
