#include <cmath>

enum { ICUT = 0, ICONV, ICONC };

/////////////////////////////////////////////////////////////
double arh( const double constVal, const double constArreh ){
/////////////////////////////////////////////////////////////

  // Compute and return arrehenius-like term
  return exp( - constArreh / constVal );
}

/////////////////////////////////////////////////////////////
double xlog( const double constVal ){
/////////////////////////////////////////////////////////////

  // Compute and return arrehenius-like term
  return constVal*log( constVal );
}

/////////////////////////////////////////////////////////////
// overloaded "mid" function
// the "mid" function overloading is implemented as a friend
// of classes McCormick & McCormick2 
/////////////////////////////////////////////////////////////
double mid( const double convRel, const double concRel,
            const double valCut, int &indexMid){
/////////////////////////////////////////////////////////////

  // Return the value associated to the index
  if ( indexMid == ICONV )
    return convRel;

  else
  if ( indexMid == ICUT )
    return valCut;

  else
  if ( indexMid == ICONC )
      return concRel;

  // Select and return the mid value and the related index
  else{
    if ( valCut < convRel ){
      indexMid = ICONV;
      return convRel;
    }
    else
    if ( valCut < concRel ){
      indexMid = ICUT;
      return valCut;
    }
    else{
      indexMid = ICONC;
      return concRel;
    }
  }
 
}

/////////////////////////////////////////////////////////////
double mid( const double *dconvReldParam,
            const double *dconcReldParam,
            const int iParam, const int indexMid ){
/////////////////////////////////////////////////////////////

  // Return the value of the 1st-order derivative associated to the index
  if ( indexMid == ICONV )
    return dconvReldParam[iParam];

  else
  if ( indexMid == ICUT )
    return 0.;

  else
    return dconcReldParam[iParam];

}

/////////////////////////////////////////////////////////////
double mid( const double *dconvReldParam,
            const double *dconcReldParam,
            const double *dvalCutdParam,
            const int iParam, const int indexMid ){
/////////////////////////////////////////////////////////////

  // Return the value of the 1st-order derivative associated to the index
  if ( indexMid == ICONV )
    return dconvReldParam[iParam];

  else
  if ( indexMid == ICUT )
    return dvalCutdParam[iParam];

  else
    return dconcReldParam[iParam];

}

// /////////////////////////////////////////////////////////////
// int min(int intL, int intU){ return (intL <= intU ? intL : intU); }
// int max(int intL, int intU){ return (intL >= intU ? intL : intU); }
// double min(double dbL, double dbU){ return (dbL <= dbU ? dbL : dbU); }
// double max(double dbL, double dbU){ return (dbL >= dbU ? dbL : dbU); }
// /////////////////////////////////////////////////////////////
